#pragma once

#include "BasicBlocks.h"

class Chest : public BasicBlock
{
private:
    bool open;
    int userEntityId;

    virtual void onDestroy() override;
    virtual void onDialogClosed(Framework::Text dialogId) override;
    Framework::Text getDialogId() const;

protected:
    virtual bool onTick(
        TickQueue* zQueue, int numTicks, bool& blocked) override;

public:
    Chest(
        int typeId, ItemType* zTool, Framework::Vec3<int> pos, int dimensionId);
    virtual bool interact(Item* zItem, Entity* zActor) override;
    virtual void sendModelInfo(NetworkMessage* zMessage) override;
};